Đến nội dung


Hình ảnh
- - - - -

offset đối tượng sau khi mirror


  • Please log in to reply
6 replies to this topic

#1 caibutchi

caibutchi

    biết pan

  • Members
  • Pip
  • 9 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 15 October 2011 - 08:40 AM

Các bác cho e hỏi xí về VBA,e muốn offset các đối tượng sau khi mirror mà sao không thực hiện dc nhỉ

b as acadline
a as variant
c as variant

a = b.mirror(A1,B1)
c= a.offset (5)

'cho em hoi tai sao cad không vẽ được đường thẳng c ạ,tương tự thế sao e không set layer cho đối tượng c được ạ.Cảm ơn các bác
  • 0

#2 anhcos

anhcos

    biết lệnh hatchedit

  • Advance Member
  • PipPipPipPip
  • 260 Bài viết
Điểm đánh giá: 170 (tàm tạm)

Đã gửi 15 October 2011 - 11:41 AM

Các bác cho e hỏi xí về VBA,e muốn offset các đối tượng sau khi mirror mà sao không thực hiện dc nhỉ

b as acadline
a as variant
c as variant

a = b.mirror(A1,B1)
c= a.offset (5)

'cho em hoi tai sao cad không vẽ được đường thẳng c ạ,tương tự thế sao e không set layer cho đối tượng c được ạ.Cảm ơn các bác


Đoạn lệnh này mình không thấy gì có lỗi.

Có những đối tượng sau khi offset thì chia thành nhiều đối tượng con, vì thế c là mảng các đối tượng sau khi offset.
Bạn kiểm tra số lượng các đối tượng và thay đổi giá trị
VD:
c(0).Layer = "cadviet"

Tổng quát hơn
for i=0 to ubound©
c(i).Layer ="0"
next i
  • 1
Clear sky!

MF Rock collection.

#3 caibutchi

caibutchi

    biết pan

  • Members
  • Pip
  • 9 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 15 October 2011 - 02:29 PM

Cảm ơn a nhưng sao em làm không được anh ạ.Nó vẫn không offset ra dc mà cũng chẳng set layer dc.Dù sao cũng cảm ơn a nha
  • 0

#4 phamngoctukts

phamngoctukts

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 1107 Bài viết
Điểm đánh giá: 696 (tốt)

Đã gửi 15 October 2011 - 06:40 PM

Cảm ơn a nhưng sao em làm không được anh ạ.Nó vẫn không offset ra dc mà cũng chẳng set layer dc.Dù sao cũng cảm ơn a nha

Đối tượng offset phải là variant bạn nhé. Bạn nghiên cứu thử đoạn code sau:

Sub ofline()
Dim al As AcadLine
Dim aml As AcadLine
Dim aol As Variant
Dim p1(0 To 2) As Double
Dim p2(0 To 2) As Double
Dim pm1(0 To 2) As Double
Dim pm2(0 To 2) As Double
p1(0) = 0: p1(1) = 0: p1(2) = 0
p2(0) = 100: p2(1) = 100: p2(2) = 0
pm1(0) = 100: pm1(1) = 0: pm1(2) = 0
pm2(0) = 100: pm2(1) = 100: pm2(2) = 0
Set al = ThisDrawing.ModelSpace.AddLine(p1, p2)
Set aml = al.Mirror(pm1, pm2)
aol = aml.Offset(50)
End Sub

  • 1
Tất cả vì sự phát triển của diễn đàn ...
Cám ơn đừng nói lời suông mà hãy nhấn Hình đã gửi!

#5 anhcos

anhcos

    biết lệnh hatchedit

  • Advance Member
  • PipPipPipPip
  • 260 Bài viết
Điểm đánh giá: 170 (tàm tạm)

Đã gửi 15 October 2011 - 09:06 PM

Bạn dùng thêm từ set là được
set a = b.mirror(A1,B1)
set c= a.offset (5)

Cái vụ set này lâu rồi không còn dùng nên chẳng nhớ được.
  • 1
Clear sky!

MF Rock collection.

#6 caibutchi

caibutchi

    biết pan

  • Members
  • Pip
  • 9 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 15 October 2011 - 09:58 PM

cảm ơn bạn anhcos và các bạn rất nhiều,Làm theo bạn anhcos thì ok.Nhưng có vài đối tượng nó ko nhận.Ví dụ e làm ngược lại thế này ạ:

b as acadline
a as variant
c as variant

a = b.offset(5)
c= a.mirror (a1,b1)
  • 0

#7 phantuhuong

phantuhuong

    biết dimstyle

  • Moderator
  • PipPipPipPipPip
  • 383 Bài viết
Điểm đánh giá: 200 (khá)

Đã gửi 16 October 2011 - 02:48 PM

Đã là đối tượng thì khi gán biến phải có chữ Set ở đầu. Trong trường hợp trên, bắt buộc đối tượng b phải là line, còn là đối tượng khác thì đương nhiên không chạy là phải
Đã là đối tượng thì khi gán biến phải có chữ Set ở đầu. Trong trường hợp trên, bắt buộc đối tượng b phải là line, còn là đối tượng khác thì đương nhiên không chạy là phải
  • 0
Bồi dưỡng Excel & VBA cho các đơn vị ở Hà Nội và khu vực lân cận

Từng bước loại đồ Tàu ra khỏi cuộc sống!